-----------------------------------------------------------------
--  File        : cdc_nosync.vhd
--  Version     : 1
--  Revision    : 0
--  Date        : 11.05.2018
--  Author      : Mark Harvey
--  Description : Clock Domain crossing example - no synchronizer circuit
------------------------------------------------------------------

library ieee ;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;


entity cdc is            
  port (
    CLK50MHz      : in std_logic;                    
    CLK33MHz      : in std_logic;
    IS_FOUR       : out std_logic              
    );
end entity cdc;

architecture arc_cdc of cdc is     

   -- internal signals
   signal counter1      : unsigned(15 downto 0) := (others => '0');
   signal counter1_slv  : std_logic_vector(15 downto 0);

    
begin
   
  -- 16bit up counter
  process (CLK50MHz)
  begin
    if (CLK50MHz'event and CLK50MHz = '1') then
        counter1 <= counter1 + 1;
    end if;
  end process;

  counter1_slv <= std_logic_vector(counter1);
  

  -- Compare
  process (CLK33MHz)
    begin
    if (CLK33MHz'event and CLK33MHz = '1') then
      if (counter1_slv = x"0004") then
        IS_FOUR <= '1';
	   else
        IS_FOUR <= '0';
		end if;
    end if;
  end process;
        


end architecture arc_cdc;
-----------------------------------------------------------------
--  End of File: cdc_nosync.vhd
-----------------------------------------------------------------
